
/*
** Math module - various mathematical routines
**
** NB:  DO NOT IMPORT OR INCLUDE THIS FILE INTO YOUR PROGRAM.
**      IT WILL BE IMPLICITLY IMPORTED.
*/

unit
module Math
    export ~.*all

    %
    % Determine the arc tangent of the given value, with result in radians.
    %
    external "math_arctan" function arctan (r : real) : real

    %
    % Determine the arc tangent of the given value, with result in degrees.
    %
    external "math_arctand" function arctand (r : real) : real

    %
    % Determine the cosine of the given angle in radians.
    %
    external "math_cos" function cos (r : real) : real

    %
    % Determine the cosine of the given angle in degrees.
    %
    external "math_cosd" function cosd (r : real) : real

    %
    % Determine the natural exponent (e ** r) of the given value.
    %
    external "math_exp" function exp (r : real) : real

    %
    % Determine the natural logarithm of the given value.
    %
    external "math_ln" function ln (r : real) : real

    %
    % Determine whether the given value is positive, zero, or negative.
    %
    external "math_sign" function sign (r : real) : -1 .. 1

    %
    % Determine the sine of the given angle in radians.
    %
    external "math_sin" function sin (r : real) : real

    %
    % Determine the sine of the given angle in degrees.
    %
    external "math_sind" function sind (r : real) : real

    %
    % Determine the square root of the given value.
    %
    external "math_sqrt" function sqrt (r : real) : real


end Math
