/*
 ** Pic module
 **
 ** NB:  DO NOT IMPORT OR INCLUDE THIS FILE INTO YOUR PROGRAM.
 **      IT WILL BE IMPLICITLY IMPORTED.
 */

unit
module pervasive Pic
    export New, Free, Draw, FileNew, Width, Height, Save,
	ScreenLoad, ScreenSave, Mirror, Flip, Rotate, Scale,
	SetTransparentColor, SetTransparentColour,
	~.*picCopy, ~.*picXor, ~.*picMerge, ~.*picUnderMerge


    % Exported constants

    const picCopy := 0
    const picXor := 1
    const picMerge := 2
    const picUnderMerge := 3

    % Exported routines

    external "pic_new" function New (x1, y1, x2, y2 : int) picId : int

    external "pic_free" procedure Free (picId : int)

    external "pic_draw" procedure Draw (picId, x, y, mode : int)

    external "pic_filenew" function FileNew (fileStr : string) : int

    external "pic_filesave" procedure Save (picId : int, fileStr : string)

    external "pic_flip" function Flip (picID : int) : int
    
    external "pic_mirror" function Mirror (picID : int) : int
    
    external "pic_rotate" 
    	function Rotate (picID, angle, xAxis, yAxis : int) : int
    
    external "pic_scale" function Scale (picID, newWidth, newHeight : int) : int
    
    external "pic_settransclr" procedure SetTransparentColour (picId, clr : int)

    external "pic_settransclr" procedure SetTransparentColor (picId, clr : int)

    procedure ScreenLoad (fileStr : string, x, y, mode : int)
	var picID : int
	picID := Pic.FileNew (fileStr)
	if picID > 0 then
	    Pic.Draw (picID, x, y, mode)
	    Pic.Free (picID)
	end if
    end ScreenLoad

    procedure ScreenSave (x1, y1, x2, y2 : int, fileStr : string)
	var picID : int
	picID := Pic.New (x1, y1, x2, y2)
	if picID > 0 then
	    Pic.Save (picID, fileStr)
	    Pic.Free (picID)
	end if
    end ScreenSave

    function Width (picId : int) : int
	external procedure pic_getdimensions (picId : int, var w : int, var h : int)

	var w, h : int

	pic_getdimensions (picId, w, h)

	result w
    end Width

    function Height (picId : int) : int
	external procedure pic_getdimensions (picId : int, var w : int, var h : int)

	var w, h : int

	pic_getdimensions (picId, w, h)

	result h
    end Height
end Pic

